﻿using System;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;

namespace WpfApplication1
{
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        string _sampleText;
        public string SampleText 
        {
            get { return _sampleText; }
            set
            {
                _sampleText = value;
                OnPropertyChanged("SampleText");
            }
        }

        DateTime _sampleDate;
        public DateTime SampleDate
        {
            get { return _sampleDate; }
            set
            {
                _sampleDate = value;
                OnPropertyChanged("SampleDate");
            }
        }

        UIElement _sampleControl;
        public UIElement SampleControl
        {
            get { return _sampleControl; }
            set
            {
                _sampleControl = value;
                OnPropertyChanged("SampleControl");
            }
        }

        public MainWindow()
        {
            InitializeComponent();

            this.SampleText = "This text";
            this.SampleDate = DateTime.Now;

            TextBox txtBox = new TextBox();
            txtBox.Text = "[sample]";
            this.SampleControl = txtBox;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string name)
        {
            if (string.IsNullOrEmpty(name) == true)
            {
                return;
            }

            if (PropertyChanged != null)
            {
                PropertyChangedEventArgs arg = new PropertyChangedEventArgs(name);
                PropertyChanged(this, arg);
            }
        }
    }
}
